## fscrypt 0.2.2

=== Makefile ===
# Makefile for fscrypt
#
# Copyright 2017 Google Inc.
# Author: Joe Richey (joerichey@google.com)
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.

# Update on each new release!!
RELEASE_VERSION = 0.2.0

NAME = fscrypt
PAM_NAME = pam_$(NAME)
PAM_MODULE = $(PAM_NAME).so

INSTALL ?= install
DESTDIR ?= /usr/local/bin
PAM_MODULE_DIR ?= /lib/security
PAM_CONFIG_DIR ?= /usr/share/pam-configs

CMD_PKG = github.com/google/$(NAME)/cmd/$(NAME)
PAM_PKG = github.com/google/$(NAME)/$(PAM_NAME)

SRC_FILES = $(shell find . -type f -name '*.go' -o -name "*.h" -o -name "*.c")
GO_FILES = $(shell find . -type f -name '*.go' -not -path "./vendor/*")
PROTO_FILES = $(shell find . -type f -name '*.proto' -not -path "./vendor/*")
C_FILES = $(shell find . -type f -name "*.h" -o -name "*.c" -not -path "./vendor/*")
GO_PKGS = $(shell go list ./... | grep -v /vendor/)

# IMAGE will be the path to our test ext4 image file.
IMAGE ?= $(NAME)_image

# MOUNT will be the path to the filesystem where our tests are run.
#
# Running "make test-setup MOUNT=/foo/bar" creates a test filesystem at that
#	location. Be sure to also run "make test-teardown MOUNT=/foo/bar".
# Running "make all MOUNT=/foo/bar" (or "make go") will run all tests on that
# 	filesystem. By default, it is the one created with "make test-setup".
MOUNT ?= /mnt/$(NAME)_mount
# Only run the integration tests if our root exists.
ifneq ("$(wildcard $(MOUNT))","")
export TEST_FILESYSTEM_ROOT = $(MOUNT)
endif

# The flags code below lets the caller of the makefile change the build flags
# for fscrypt in a familiar manner.
#	CFLAGS
#		Change the flags passed to the C compiler. Default = "-O2 -Wall"
#		For example:
#			make fscrypt "CFLAGS = -O3 -Werror"
#		builds the C code with high optimizations, and C warnings fail.
#	LDFLAGS
#		Change the flags passed to the C linker. Empty by default.
#		For example (on my system with additional dev packages):
#			make fscrypt "LDFLAGS = -static -ldl -laudit -lcap-ng"
#		will build a static fscrypt binary.
#	GO_FLAGS
#		Change the flags passed to "go build". Empty by default.
#		For example:
#			make fscrypt "GO_FLAGS = -race"
#		will build the Go code with race detection.
#	GO_LINK_FLAGS
#		Change the flags passed to the Go linker. Default = "-s -w"
#		For example:
#			make fscrypt GO_LINK_FLAGS=""
#		will not strip the binary.

# Set the C flags so we don't need to set C flags in each CGO file.
CFLAGS ?= -O2 -Wall
export CGO_CFLAGS = $(CFLAGS)

# By default, we strip the binary to reduce size.
GO_LINK_FLAGS ?= -s -w

# Pass the version to the command line program (pulled from tags).
TAG_VERSION = $(shell git describe --tags)
VERSION = $(if $(TAG_VERSION),$(TAG_VERSION),$(RELEASE_VERSION))
VERSION_FLAG = -X "main.version=$(VERSION)"

# Pass the current date and time to the command line program.
DATE_FLAG = -X "main.buildTime=$(shell date)"
# Add the version, date, and any specified LDFLAGS to any user-specified flags.
override GO_LINK_FLAGS += $(VERSION_FLAG) $(DATE_FLAG) -extldflags "$(LDFLAGS)"
# Add the link flags to any user-specified flags.
override GO_FLAGS += --ldflags '$(GO_LINK_FLAGS)'

.PHONY: default all

default: $(NAME) $(PAM_MODULE)
all: format lint default test

$(NAME): $(SRC_FILES)
	go build $(GO_FLAGS) -o $(NAME) $(CMD_PKG)

$(PAM_MODULE): $(SRC_FILES)
	go build -buildmode=c-shared $(GO_FLAGS) -o $(PAM_MODULE) $(PAM_PKG)
	rm -f $(PAM_NAME).h

.PHONY: clean
clean:
	rm -f $(NAME) $(PAM_MODULE) $(IMAGE)

# Make sure go files build and tests pass.
.PHONY: test
test:
	@go test -p 1 $(GO_FLAGS) $(GO_PKGS)

# Make sure the protocol buffers are generated
.PHONY: gen
gen:
	protoc --go_out=. $(PROTO_FILES)

# Update the vendored dependencies.
.PHONY: update
update:
	govendor init
	govendor fetch +missing
	govendor add +external
	govendor remove +unused

# Format all the Go and C code
.PHONY: format format-check
format:
	goimports -l -w $(GO_FILES)
	clang-format -i -style=Google $(C_FILES)

format-check:
	@goimports -d $(GO_FILES) \
	| ./input_fail.py "Incorrectly formatted Go files. Run \"make format\"."
	@clang-format -i -style=Google -output-replacements-xml $(C_FILES) \
	| grep "<replacement " \
	| ./input_fail.py "Incorrectly formatted C files. Run \"make format\"."

# Run lint rules (skipping generated files)
.PHONY: lint
lint:
	@go tool vet -buildtags=false .
	@golint $(GO_PKGS) | grep -v "pb.go" | ./input_fail.py
	@megacheck -unused.exported $(GO_PKGS)

###### Installation commands #####
.PHONY: install_bin install_pam install uninstall
install_bin: $(NAME)
	$(INSTALL) -d $(DESTDIR)
	$(INSTALL) $(NAME) $(DESTDIR)

install_pam: $(PAM_MODULE)
	$(INSTALL) -d $(PAM_MODULE_DIR)
	$(INSTALL) $(PAM_MODULE) $(PAM_MODULE_DIR)
	$(INSTALL) -d $(PAM_CONFIG_DIR)
	$(INSTALL) $(PAM_NAME)/config $(PAM_CONFIG_DIR)/$(NAME)

install: install_bin install_pam 

uninstall:
	rm -f $(DESTDIR)/$(NAME) $(PAM_MODULE_DIR)/$(PAM_MODULE) $(PAM_CONFIG_DIR)/$(NAME)

# Install the go tools used for checking/generating the code
.PHONY: go-tools
go-tools:
	go get -u github.com/golang/protobuf/protoc-gen-go
	go get -u github.com/golang/lint/golint
	go get -u github.com/kardianos/govendor
	go get -u golang.org/x/tools/cmd/goimports
	go get -u honnef.co/go/tools/cmd/megacheck

##### Setup/Teardown for integration tests (need root permissions) #####
.PHONY: test-setup test-teardown
test-setup:
	dd if=/dev/zero of=$(IMAGE) bs=1M count=20
	mkfs.ext4 -b 4096 -O encrypt $(IMAGE) -F
	sudo mkdir -p $(MOUNT)
	sudo mount -o rw,loop $(IMAGE) $(MOUNT)
	sudo chmod +777 $(MOUNT)

test-teardown:
	sudo umount $(MOUNT)
	sudo rmdir $(MOUNT)
	rm -f $(IMAGE)

##### Travis CI Commands
.PHONY: travis-setup travis-script
travis-install: go-tools test-setup
	go get -u github.com/mattn/goveralls

travis-script: lint format-check test default
	goveralls -service=travis-ci
	@govendor list +missing +external +unused \
	| ./input_fail.py "Incorrect vendored dependencies. Run \"make update\"."

=== debian/changelog ===
fscrypt (0.2.2-0ubuntu2) bionic; urgency=medium

  * debian/copyright: Add copyright information for pam/constants.go

 -- Tyler Hicks <tyhicks@canonical.com>  Mon, 30 Oct 2017 14:43:14 +0000

fscrypt (0.2.2-0ubuntu1) bionic; urgency=medium

  * Initial release

 -- Tyler Hicks <tyhicks@canonical.com>  Fri, 27 Oct 2017 22:14:46 +0000

=== debian/control ===
Source: fscrypt
Section: misc
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Uploaders: Tyler Hicks <tyhicks@canonical.com>
Build-Depends: debhelper (>= 10),
               dh-exec,
               dh-golang,
               golang-any,
               golang-github-pkg-errors-dev,
               golang-github-urfave-cli-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-sys-dev,
               golang-goprotobuf-dev,
               libargon2-0-dev (>= 0~20161029),
               libblkid-dev,
               libpam0g-dev,
Standards-Version: 4.1.0
Homepage: https://github.com/google/fscrypt
XS-Go-Import-Path: github.com/google/fscrypt
Testsuite: autopkgtest-pkg-go

Package: fscrypt
Architecture: linux-any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: e2fsprogs (>= 1.43~WIP.2015.05.18-1)
Description: Tool for managing Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping, PAM
 integration, and provides a uniform interface for creating and modifying
 encrypted directories.
 .
 To use fscrypt, you must have a filesystem with encryption enabled and a
 kernel that supports reading/writing from that filesystem. Currently, ext4,
 F2FS, and UBIFS support Linux filesystem encryption.

Package: libpam-fscrypt
Architecture: linux-any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         fscrypt
Description: PAM module for Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping, PAM
 integration, and provides a uniform interface for creating and modifying
 encrypted directories.
 .
 This PAM module can be used to unlock one or more directories upon user login
 and then lock those directories when the user ends their session.

Package: golang-github-google-fscrypt-dev
Architecture: linux-any
Depends: ${misc:Depends},
         golang-go,
         golang-github-pkg-errors-dev,
         golang-github-urfave-cli-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-sys-dev,
         golang-goprotobuf-dev,
Description: Linux filesystem encryption source code
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping, PAM
 integration, and provides a uniform interface for creating and modifying
 encrypted directories.
 .
 This package contains the source tree of the fscrypt project.

=== debian/rules ===
#!/usr/bin/make -f

export GOPATH = $(CURDIR)/_build:/usr/share/gocode

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_build:
	# use upstream's Makefile for building since pam_fscrypt.so needs to
	# build in c-shared mode but dh-golang doesn't support that mode
	$(MAKE)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/fscrypt-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/google/fscrypt/tags .*/v?(\d\S*)\.tar\.gz

## fscrypt 0.2.4

=== Makefile ===
# Makefile for fscrypt
#
# Copyright 2017 Google Inc.
# Author: Joe Richey (joerichey@google.com)
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.

# Update on each new release!!
VERSION := v0.2.4
NAME := fscrypt
PAM_NAME := pam_$(NAME)

###### Makefile Command Line Flags ######
#
# BIN: The locaton where binaries will be built.    Default: ./bin
# INSTALL: The tool used to install binaries.       Default: sudo install
# DESTDIR: The location for the fscrypt binary.     Default: /usr/local/bin
# PAM_MODULE_DIR: The location for pam_fscrypt.so.  Default: /lib/security
#
# MOUNT: The filesystem where our tests are run.    Default: /mnt/fscrypt_mount
#   Ex: make test-setup MOUNT=/foo/bar
#     Creates a test filesystem at that location.
#   Ex: make test-teardown MOUNT=/foo/bar
#     Cleans up a test filesystem created with "make test-setup".
#   Ex: make test MOUNT=/foo/bar
#     Run all integration tests on that filesystem. This can be an existing
#     filesystem, or one created with "make test-setup" (this is the default).
#
# CFLAGS: The flags passed to the C compiler.       Default: -O2 -Wall
#   Ex: make fscrypt "CFLAGS = -O3 -Werror"
#     Builds fscrypt with the C code failing on warnings and highly optimized.
#
# LDFLAGS: The flags passed to the C linker.        Default empty
#   Ex: make fscrypt "LDFLAGS = -static -ldl -laudit -lcap-ng"
#     Builds fscrypt as a static binary.
#
# GO_FLAGS: The flags passed to "go build".         Default empty
#   Ex: make fscrypt "GO_FLAGS = -race"
#     Builds fscrypt with race detection for the go code.
#
# GO_LINK_FLAGS: The flags passed to the go linker. Default: -s -w
#   Ex: make fscrypt GO_LINK_FLAGS=""
#     Builds fscrypt without stripping the binary.

BIN := bin
export PATH := $(BIN):$(PATH)
PAM_MODULE := $(BIN)/$(PAM_NAME).so

###### Setup Build Flags #####
CFLAGS := -O2 -Wall
# Pass CFLAGS to each cgo invocation.
export CGO_CFLAGS = $(CFLAGS)
# By default, we strip the binary to reduce size.
GO_LINK_FLAGS := -s -w

# Flag to embed the version (pulled from tags) into the binary.
TAG_VERSION := $(shell git describe --tags)
VERSION_FLAG := -X "main.version=$(if $(TAG_VERSION),$(TAG_VERSION),$(VERSION))"
# Flag to embed the date and time of the build into the binary.
DATE_FLAG := -X "main.buildTime=$(shell date)"

override GO_LINK_FLAGS += $(VERSION_FLAG) $(DATE_FLAG) -extldflags "$(LDFLAGS)"
override GO_FLAGS += --ldflags '$(GO_LINK_FLAGS)'

###### Find All Files and Directories ######
FILES := $(shell find . \( -path ./vendor -o -path "./.*" \) -prune -o -type f -printf "%P\n")
GO_FILES := $(filter %.go,$(FILES))
GO_DIRS := $(sort $(dir $(GO_FILES)))
C_FILES := $(filter %.c %.h,$(FILES))
PROTO_FILES := $(filter %.proto,$(FILES))

###### Build, Formatting, and Linting Commands ######
.PHONY: default all gen format lint clean
default: $(BIN)/$(NAME) $(PAM_MODULE)
all: tools gen default format lint test

$(BIN)/$(NAME): $(GO_FILES) $(C_FILES)
	go build $(GO_FLAGS) -o $@ ./cmd/$(NAME)

$(PAM_MODULE): $(GO_FILES) $(C_FILES)
	go build -buildmode=c-shared $(GO_FLAGS) -o $@ ./$(PAM_NAME)
	rm -f $(BIN)/$(PAM_NAME).h

gen: $(BIN)/protoc $(BIN)/protoc-gen-go $(PROTO_FILES)
	protoc --go_out=. $(PROTO_FILES)

format: $(BIN)/goimports
	goimports -w $(GO_DIRS)
	clang-format -i -style=Google $(C_FILES)

lint: $(BIN)/golint $(BIN)/megacheck
	go vet ./...
	golint -set_exit_status ./...
	megacheck -unused.exported -simple.exit-non-zero ./...

clean:
	rm -f $(BIN)/$(NAME) $(PAM_MODULE) $(TOOLS) coverage.out $(COVERAGE_FILES)

###### Testing Commands (setup/teardown require sudo) ######
.PHONY: test test-setup test-teardown

# If MOUNT exists signal that we should run integration tests.
MOUNT := /tmp/$(NAME)-mount
IMAGE := /tmp/$(NAME)-image
ifneq ("$(wildcard $(MOUNT))","")
export TEST_FILESYSTEM_ROOT = $(MOUNT)
endif

test:
	go test -p 1 ./...

test-setup:
	dd if=/dev/zero of=$(IMAGE) bs=1M count=20
	mkfs.ext4 -b 4096 -O encrypt $(IMAGE) -F
	mkdir -p $(MOUNT)
	sudo mount -o rw,loop,user $(IMAGE) $(MOUNT)
	sudo chmod +777 $(MOUNT)

test-teardown:
	sudo umount $(MOUNT)
	rmdir $(MOUNT)
	rm -f $(IMAGE)

# Runs tests and generates coverage
COVERAGE_FILES := $(addsuffix coverage.out,$(GO_DIRS))
coverage.out: $(BIN)/gocovmerge $(COVERAGE_FILES)
	@gocovmerge $(COVERAGE_FILES) > $@

%/coverage.out: $(GO_FILES) $(C_FILES)
	@go test -coverpkg=./... -covermode=count -coverprofile=$@ -p 1 ./$* 2> /dev/null

###### Installation Commands (require sudo) #####
.PHONY: install install-bin install-pam uninstall
install: install-bin install-pam

INSTALL := sudo install
DESTDIR := /usr/local/bin
PAM_MODULE_DIR := /lib/security
PAM_CONFIG_DIR := /usr/share/pam-configs

install-bin: $(BIN)/$(NAME)
	$(INSTALL) -d $(DESTDIR)
	$(INSTALL) $< $(DESTDIR)

install-pam: $(PAM_MODULE)
	$(INSTALL) -d $(PAM_MODULE_DIR)
	$(INSTALL) $< $(PAM_MODULE_DIR)
	$(INSTALL) -d $(PAM_CONFIG_DIR)
	$(INSTALL) $(PAM_NAME)/config $(PAM_CONFIG_DIR)/$(NAME)

uninstall:
	rm -f $(DESTDIR)/$(NAME) $(PAM_MODULE_DIR)/$(PAM_MODULE) $(PAM_CONFIG_DIR)/$(NAME)

#### Tool Building Commands ####
TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports megacheck gocovmerge)
.PHONY: tools
tools: $(TOOLS)

# Go tools build from vendored sources
VENDOR := $(shell find vendor -type f)
$(BIN)/golint: $(VENDOR)
	go build -o $@ ./vendor/github.com/golang/lint/golint
$(BIN)/protoc-gen-go: $(VENDOR)
	go build -o $@ ./vendor/github.com/golang/protobuf/protoc-gen-go
$(BIN)/goimports: $(VENDOR)
	go build -o $@ ./vendor/golang.org/x/tools/cmd/goimports
$(BIN)/megacheck: $(VENDOR)
	go build -o $@ ./vendor/honnef.co/go/tools/cmd/megacheck
$(BIN)/gocovmerge: $(VENDOR)
	go build -o $@ ./vendor/github.com/wadey/gocovmerge

# Non-go tools downloaded from appropriate repository
PROTOC_VERSION := 3.5.1
ARCH := $(shell uname -m)
ifeq (x86_64,$(ARCH))
PROTOC_ARCH := x86_64
else ifneq ($(filter i386 i686,$(ARCH)),)
PROTOC_ARCH := x86_32
else ifneq ($(filter aarch64 armv8l,$(ARCH)),)
PROTOC_ARCH := aarch_64
endif
ifdef PROTOC_ARCH
PROTOC_URL := https://github.com/google/protobuf/releases/download/v$(PROTOC_VERSION)/protoc-$(PROTOC_VERSION)-linux-$(PROTOC_ARCH).zip
$(BIN)/protoc:
	wget -q $(PROTOC_URL) -O /tmp/protoc.zip
	unzip -q -j /tmp/protoc.zip bin/protoc -d $(BIN)
else
PROTOC_PATH := $(shell which protoc)
$(BIN)/protoc: $(PROTOC_PATH)
ifneq ($(wildcard $(PROTOC_PATH)),)
	cp $< $@
else
	$(error Could not download protoc binary or locate it on the system. Please install it)
endif
endif

=== debian/changelog ===
fscrypt (0.2.4-2+deb10u1) buster-security; urgency=medium

  * Non-maintainer upload by the LTS team.
  * Rebuild against golang-go.crypto 1:0.0~git20181203.505ab14-1+deb10u1.

 -- Markus Koschany <apo@debian.org>  Tue, 13 Jun 2023 13:16:08 +0200

fscrypt (0.2.4-2) unstable; urgency=medium

  * Use team+pkg-go@tracker.debian.org in Maintainer
  * Versioned dependency on golang-any >= 2:1.10~ (see README.md)
  * Disable filesystem tests (require an ad-hoc filesystem and root)
    Fixes FTBFS on ppc64el.
  * Versioned dependency on dh-golang >= 1.35 (fixes FTBFS with gccgo-8)
  * Make the PAM library installation rules work with gccgo-go

 -- Paride Legovini <pl@ninthfloor.org>  Sat, 25 Aug 2018 12:48:36 +0000

fscrypt (0.2.4-1) unstable; urgency=medium

  * New upstream version. Fixes: CVE-2018-6558.
  * Bump Standards-Versions to 4.2.0 (no changes needed)
  * gbp.conf: set upstream-branch = upstream/latest (DEP14)
  * Improve the installation rules for the binary and PAM library
  * Run all the tests but the failing ones instead of disabling all of them
  * Verbose build (DH_VERBOSE = 1)

 -- Paride Legovini <pl@ninthfloor.org>  Thu, 23 Aug 2018 07:55:41 +0000

fscrypt (0.2.3-2) unstable; urgency=medium

  * Do not set ‘-buildmode=pie’ on mips/mipsel/mips64el
  * Fix the PAM library installation rule for non-amd64 archs

 -- Paride Legovini <pl@ninthfloor.org>  Tue, 10 Apr 2018 14:21:55 +0000

fscrypt (0.2.3-1) unstable; urgency=medium

  * Initial release (Closes: #894406)

 -- Paride Legovini <pl@ninthfloor.org>  Mon, 09 Apr 2018 17:06:27 +0000

=== debian/control ===
Source: fscrypt
Section: admin
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Paride Legovini <pl@ninthfloor.org>
Build-Depends: debhelper (>= 11),
               dh-exec,
               dh-golang (>= 1.35),
               golang-any (>= 2:1.10~),
               golang-github-pkg-errors-dev,
               golang-github-urfave-cli-dev,
               golang-golang-x-crypto-dev (>= 1:0.0~git20181203.505ab14-1+deb10u1),
               golang-golang-x-sys-dev,
               golang-goprotobuf-dev,
               libpam0g-dev
Standards-Version: 4.2.0
Homepage: https://github.com/google/fscrypt
Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
XS-Go-Import-Path: github.com/google/fscrypt
Testsuite: autopkgtest-pkg-go

Package: fscrypt
Architecture: linux-any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Suggests: libpam-fscrypt
Description: Tool for managing Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping,
 PAM integration, and provides a uniform interface for creating and
 modifying encrypted directories.
 .
 To use fscrypt, you must have a filesystem with encryption enabled and
 a kernel that supports reading/writing from that filesystem. Currently,
 ext4, F2FS, and UBIFS support Linux filesystem encryption. Ext4 has
 supported Linux filesystem encryption since v4.1, F2FS added support
 in v4.2, and UBIFS added support in v4.10. Other filesystems may add
 support for native encryption in the future.

Package: libpam-fscrypt
Architecture: linux-any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends},
         fscrypt
Description: PAM module for Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping,
 PAM integration, and provides a uniform interface for creating and
 modifying encrypted directories.
 .
 This PAM module can be used to unlock one or more directories upon user
 login and then lock those directories when the user ends their session.

#Package: golang-github-google-fscrypt-dev
#Architecture: all
#Depends: ${misc:Depends},
#         golang-github-pkg-errors-dev,
#         golang-github-urfave-cli-dev,
#         golang-golang-x-crypto-dev (>= 1:0.0~git20180322.88942b9),
#         golang-golang-x-sys-dev,
#         golang-goprotobuf-dev
#Description: Linux filesystem encryption source code
# fscrypt is a high-level tool for the management of Linux filesystem
# encryption. This tool manages metadata, key generation, key wrapping,
# PAM integration, and provides a uniform interface for creating and
# modifying encrypted directories.
# .
# This package contains the source tree of the fscrypt project.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE = 1

# https://wiki.debian.org/HardeningWalkthrough
export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DH_GOPKG := github.com/google/fscrypt

### Set some build flags.
### Partially borrowed from upstream Makefile

# As of Go 1.11, -buildmode=pie not supported on linux/mips.
#
# REMINDER:
# On new releases of Go check the release notes to see if we can get
# rid of this exclusion. E.g. https://golang.org/doc/go1.11#compiler
ifeq ($(filter $(DEB_HOST_ARCH),mips mipsel mips64el),)
GO_FLAGS += -buildmode=pie
endif

GO_LINK_FLAGS := -s -w
VERSION_FLAG := -X "main.version=v$(DEB_VERSION_UPSTREAM)"
GO_LINK_FLAGS += $(VERSION_FLAG) -extldflags "$(LDFLAGS)"
GO_FLAGS += --ldflags '$(GO_LINK_FLAGS)'

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_build:
	# Build the command line tool
	DH_GOLANG_BUILDPKG=$(DH_GOPKG)/cmd/... dh_auto_build -O--buildsystem=golang -- $(GO_FLAGS)

	# Build the PAM module (C shared library)
	DH_GOLANG_BUILDPKG=$(DH_GOPKG)/pam_fscrypt/... dh_auto_build -O--buildsystem=golang -- $(GO_FLAGS) -buildmode=c-shared

	# Workaround for https://github.com/golang/go/issues/24253
	# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=903385
	#
	# golang-go calls the library pam_fscrypt.a, while gccgo-go calls it libpam_fscrypt.a.
	# One thing we (hopefully) now: there is only one .a file. Its path is also difficult
	# to predict. Let's try to write a command that will always rename it to pam_fscrypt.so.
	ls -l obj-*/pkg/*/$(DH_GOPKG)/*.a
	SOPATH=$$(dirname obj-*/pkg/*/$(DH_GOPKG)/*.a) && mv -v $$SOPATH/*.a $$SOPATH/pam_fscrypt.so

	# Old workaround, for future reference:
	#rename.ul -v .a .so obj-*/pkg/*/$(DH_GOPKG)/*.a

override_dh_auto_test:
	# Excluded tests:
	#
	# crypto:     needs a user keyring linked into the session keyring
	#             https://github.com/google/fscrypt/issues/99
	# filesystem: requires a filesystem to test upon and root privileges

	DH_GOLANG_EXCLUDES="crypto filesystem" dh_auto_test

## fscrypt 0.2.5

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # the License.
 
 # Update on each new release!!
-VERSION := v0.2.4
+VERSION := v0.2.5
 NAME := fscrypt
 PAM_NAME := pam_$(NAME)
 
@@ -75,6 +75,7 @@
 ###### Find All Files and Directories ######
 FILES := $(shell find . \( -path ./vendor -o -path "./.*" \) -prune -o -type f -printf "%P\n")
 GO_FILES := $(filter %.go,$(FILES))
+GO_NONGEN_FILES := $(filter-out %.pb.go,$(GO_FILES))
 GO_DIRS := $(sort $(dir $(GO_FILES)))
 C_FILES := $(filter %.c %.h,$(FILES))
 PROTO_FILES := $(filter %.proto,$(FILES))
@@ -95,16 +96,17 @@
 	protoc --go_out=. $(PROTO_FILES)
 
 format: $(BIN)/goimports
-	goimports -w $(GO_DIRS)
+	goimports -w $(GO_NONGEN_FILES)
 	clang-format -i -style=Google $(C_FILES)
 
-lint: $(BIN)/golint $(BIN)/megacheck
+lint: $(BIN)/golint $(BIN)/staticcheck $(BIN)/misspell
 	go vet ./...
-	golint -set_exit_status ./...
-	megacheck -unused.exported -simple.exit-non-zero ./...
+	go list ./... | xargs -L1 golint -set_exit_status
+	staticcheck ./...
+	misspell -source=text $(FILES)
 
 clean:
-	rm -f $(BIN)/$(NAME) $(PAM_MODULE) $(TOOLS) coverage.out $(COVERAGE_FILES)
+	rm -f $(BIN)/$(NAME) $(PAM_MODULE) $(TOOLS) coverage.out $(COVERAGE_FILES) $(PAM_CONFIG)
 
 ###### Testing Commands (setup/teardown require sudo) ######
 .PHONY: test test-setup test-teardown
@@ -143,44 +145,57 @@
 .PHONY: install install-bin install-pam uninstall
 install: install-bin install-pam
 
-INSTALL := sudo install
-DESTDIR := /usr/local/bin
-PAM_MODULE_DIR := /lib/security
-PAM_CONFIG_DIR := /usr/share/pam-configs
+PREFIX := /usr/local
+DESTDIR := $(PREFIX)/bin
 
 install-bin: $(BIN)/$(NAME)
-	$(INSTALL) -d $(DESTDIR)
-	$(INSTALL) $< $(DESTDIR)
+	install -d $(DESTDIR)
+	install $< $(DESTDIR)
+
+PAM_MODULE_DIR := $(PREFIX)/lib/security
+PAM_INSTALL_PATH := $(PAM_MODULE_DIR)/$(PAM_NAME).so
+PAM_CONFIG := $(BIN)/config
+PAM_CONFIG_DIR := $(PREFIX)/share/pam-configs
 
 install-pam: $(PAM_MODULE)
-	$(INSTALL) -d $(PAM_MODULE_DIR)
-	$(INSTALL) $< $(PAM_MODULE_DIR)
-	$(INSTALL) -d $(PAM_CONFIG_DIR)
-	$(INSTALL) $(PAM_NAME)/config $(PAM_CONFIG_DIR)/$(NAME)
+	install -d $(PAM_MODULE_DIR)
+	install $(PAM_MODULE) $(PAM_MODULE_DIR)
+
+	m4 --define=PAM_INSTALL_PATH=$(PAM_INSTALL_PATH) < $(PAM_NAME)/config > $(PAM_CONFIG)
+	install -d $(PAM_CONFIG_DIR)
+	install $(PAM_CONFIG) $(PAM_CONFIG_DIR)/$(NAME)
 
 uninstall:
-	rm -f $(DESTDIR)/$(NAME) $(PAM_MODULE_DIR)/$(PAM_MODULE) $(PAM_CONFIG_DIR)/$(NAME)
+	rm -f $(DESTDIR)/$(NAME) $(PAM_INSTALL_PATH) $(PAM_CONFIG_DIR)/$(NAME)
 
 #### Tool Building Commands ####
-TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports megacheck gocovmerge)
+TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports staticcheck gocovmerge misspell)
 .PHONY: tools
 tools: $(TOOLS)
 
-# Go tools build from vendored sources
-VENDOR := $(shell find vendor -type f)
-$(BIN)/golint: $(VENDOR)
-	go build -o $@ ./vendor/github.com/golang/lint/golint
-$(BIN)/protoc-gen-go: $(VENDOR)
-	go build -o $@ ./vendor/github.com/golang/protobuf/protoc-gen-go
-$(BIN)/goimports: $(VENDOR)
-	go build -o $@ ./vendor/golang.org/x/tools/cmd/goimports
-$(BIN)/megacheck: $(VENDOR)
-	go build -o $@ ./vendor/honnef.co/go/tools/cmd/megacheck
-$(BIN)/gocovmerge: $(VENDOR)
-	go build -o $@ ./vendor/github.com/wadey/gocovmerge
+$(BIN)/golint:
+	GO111MODULE=off go get golang.org/x/lint/golint
+	GO111MODULE=off go build -o $@ golang.org/x/lint/golint
+$(BIN)/protoc-gen-go:
+	GO111MODULE=off go get -d github.com/golang/protobuf/protoc-gen-go
+	git -C "$(shell go env GOPATH)/src/github.com/golang/protobuf" checkout v1.2.0
+	go install github.com/golang/protobuf/protoc-gen-go
+	GO111MODULE=off go build -o $@ github.com/golang/protobuf/protoc-gen-go
+$(BIN)/goimports:
+	GO111MODULE=off go get golang.org/x/tools/cmd/goimports
+	GO111MODULE=off go build -o $@ golang.org/x/tools/cmd/goimports
+$(BIN)/staticcheck:
+	GO111MODULE=off go get honnef.co/go/tools/cmd/staticcheck
+	GO111MODULE=off go build -o $@ honnef.co/go/tools/cmd/staticcheck
+$(BIN)/gocovmerge:
+	GO111MODULE=off go get github.com/wadey/gocovmerge
+	GO111MODULE=off go build -o $@ github.com/wadey/gocovmerge
+$(BIN)/misspell:
+	GO111MODULE=off go get github.com/client9/misspell
+	GO111MODULE=off go build -o $@ github.com/client9/misspell/cmd/misspell
 
 # Non-go tools downloaded from appropriate repository
-PROTOC_VERSION := 3.5.1
+PROTOC_VERSION := 3.6.1
 ARCH := $(shell uname -m)
 ifeq (x86_64,$(ARCH))
 PROTOC_ARCH := x86_64

=== debian/changelog ===
fscrypt (0.2.5-2) unstable; urgency=medium

  * The upstream libpam config file is now a template; compile it.
    (Closes: #946155)
  * Build-Depend on m4.

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 04 Dec 2019 13:57:04 +0000

fscrypt (0.2.5-1) unstable; urgency=medium

  * New upstream version 0.2.5 (Closes: #945398).
  * Build-Depend on debhelper-compat and drop d/compat.
  * Bump Standards-Version to 4.4.1 (no changes needed).
  * d/control: add Rules-Requires-Root: no.
  * d/rules: drop DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed.
    ld --as-needed is enabled by default on Debian development versions.

 -- Paride Legovini <pl@ninthfloor.org>  Sat, 30 Nov 2019 15:20:33 +0000

=== debian/control ===
--- 
+++ 
@@ -3,22 +3,24 @@
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Paride Legovini <pl@ninthfloor.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                dh-exec,
                dh-golang (>= 1.35),
                golang-any (>= 2:1.10~),
                golang-github-pkg-errors-dev,
                golang-github-urfave-cli-dev,
-               golang-golang-x-crypto-dev (>= 1:0.0~git20181203.505ab14-1+deb10u1),
+               golang-golang-x-crypto-dev (>= 1:0.0~git20180322.88942b9),
                golang-golang-x-sys-dev,
                golang-goprotobuf-dev,
-               libpam0g-dev
-Standards-Version: 4.2.0
+               libpam0g-dev,
+               m4
+Standards-Version: 4.4.1
 Homepage: https://github.com/google/fscrypt
 Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
 Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
 XS-Go-Import-Path: github.com/google/fscrypt
 Testsuite: autopkgtest-pkg-go
+Rules-Requires-Root: no
 
 Package: fscrypt
 Architecture: linux-any

=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,8 @@
 
 include /usr/share/dpkg/pkg-info.mk
 
-export DH_VERBOSE = 1
-
 # https://wiki.debian.org/HardeningWalkthrough
-export DEB_BUILD_MAINT_OPTIONS  = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DH_GOPKG := github.com/google/fscrypt
 
@@ -41,7 +38,7 @@
 	# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=903385
 	#
 	# golang-go calls the library pam_fscrypt.a, while gccgo-go calls it libpam_fscrypt.a.
-	# One thing we (hopefully) now: there is only one .a file. Its path is also difficult
+	# One thing we (hopefully) know: there is only one .a file. Its path is also difficult
 	# to predict. Let's try to write a command that will always rename it to pam_fscrypt.so.
 	ls -l obj-*/pkg/*/$(DH_GOPKG)/*.a
 	SOPATH=$$(dirname obj-*/pkg/*/$(DH_GOPKG)/*.a) && mv -v $$SOPATH/*.a $$SOPATH/pam_fscrypt.so
@@ -57,3 +54,11 @@
 	# filesystem: requires a filesystem to test upon and root privileges
 
 	DH_GOLANG_EXCLUDES="crypto filesystem" dh_auto_test
+
+override_dh_install:
+	dh_install
+
+	# Adapted from the upstream Makefile
+	m4 --define=PAM_INSTALL_PATH=pam_fscrypt.so \
+		< pam_fscrypt/config \
+		> $(CURDIR)/debian/libpam-fscrypt/usr/share/pam-configs/fscrypt

## fscrypt 0.2.9

=== Makefile ===
--- 
+++ 
@@ -16,16 +16,18 @@
 # the License.
 
 # Update on each new release!!
-VERSION := v0.2.5
+VERSION := v0.2.9
 NAME := fscrypt
 PAM_NAME := pam_$(NAME)
 
 ###### Makefile Command Line Flags ######
 #
-# BIN: The locaton where binaries will be built.    Default: ./bin
-# INSTALL: The tool used to install binaries.       Default: sudo install
-# DESTDIR: The location for the fscrypt binary.     Default: /usr/local/bin
-# PAM_MODULE_DIR: The location for pam_fscrypt.so.  Default: /lib/security
+# BIN: The location where binaries will be built.     Default: bin
+# DESTDIR: Installation destination directory.        Default: ""
+# PREFIX: Installation path prefix.                   Default: /usr/local
+# BINDIR: Where to install the fscrypt binary.        Default: $(PREFIX)/bin
+# PAM_MODULE_DIR: Where to install pam_fscrypt.so.    Default: $(PREFIX)/lib/security
+# PAM_CONFIG_DIR: Where to install Ubuntu PAM config. Default: $(PREFIX)/share/pam-configs
 #
 # MOUNT: The filesystem where our tests are run.    Default: /mnt/fscrypt_mount
 #   Ex: make test-setup MOUNT=/foo/bar
@@ -66,14 +68,18 @@
 # Flag to embed the version (pulled from tags) into the binary.
 TAG_VERSION := $(shell git describe --tags)
 VERSION_FLAG := -X "main.version=$(if $(TAG_VERSION),$(TAG_VERSION),$(VERSION))"
-# Flag to embed the date and time of the build into the binary.
-DATE_FLAG := -X "main.buildTime=$(shell date)"
-
-override GO_LINK_FLAGS += $(VERSION_FLAG) $(DATE_FLAG) -extldflags "$(LDFLAGS)"
+
+override GO_LINK_FLAGS += $(VERSION_FLAG) -extldflags "$(LDFLAGS)"
 override GO_FLAGS += --ldflags '$(GO_LINK_FLAGS)'
+# Always use Go modules
+export GO111MODULE = on
+# Use -trimpath if available
+ifneq "" "$(shell go help build | grep trimpath)"
+override GO_FLAGS += -trimpath
+endif
 
 ###### Find All Files and Directories ######
-FILES := $(shell find . \( -path ./vendor -o -path "./.*" \) -prune -o -type f -printf "%P\n")
+FILES := $(shell find . -path '*/.git*' -prune -o -type f -printf "%P\n")
 GO_FILES := $(filter %.go,$(FILES))
 GO_NONGEN_FILES := $(filter-out %.pb.go,$(GO_FILES))
 GO_DIRS := $(sort $(dir $(GO_FILES)))
@@ -104,11 +110,12 @@
 	go list ./... | xargs -L1 golint -set_exit_status
 	staticcheck ./...
 	misspell -source=text $(FILES)
+	( cd cli-tests && shellcheck -x *.sh)
 
 clean:
 	rm -f $(BIN)/$(NAME) $(PAM_MODULE) $(TOOLS) coverage.out $(COVERAGE_FILES) $(PAM_CONFIG)
 
-###### Testing Commands (setup/teardown require sudo) ######
+###### Go tests ######
 .PHONY: test test-setup test-teardown
 
 # If MOUNT exists signal that we should run integration tests.
@@ -133,6 +140,15 @@
 	rmdir $(MOUNT)
 	rm -f $(IMAGE)
 
+###### Command-line interface tests ######
+.PHONY: cli-test cli-test-update
+
+cli-test: $(BIN)/$(NAME)
+	sudo cli-tests/run.sh
+
+cli-test-update: $(BIN)/$(NAME)
+	sudo cli-tests/run.sh --update-output
+
 # Runs tests and generates coverage
 COVERAGE_FILES := $(addsuffix coverage.out,$(GO_DIRS))
 coverage.out: $(BIN)/gocovmerge $(COVERAGE_FILES)
@@ -146,11 +162,11 @@
 install: install-bin install-pam
 
 PREFIX := /usr/local
-DESTDIR := $(PREFIX)/bin
+BINDIR := $(PREFIX)/bin
 
 install-bin: $(BIN)/$(NAME)
-	install -d $(DESTDIR)
-	install $< $(DESTDIR)
+	install -d $(DESTDIR)$(BINDIR)
+	install $< $(DESTDIR)$(BINDIR)
 
 PAM_MODULE_DIR := $(PREFIX)/lib/security
 PAM_INSTALL_PATH := $(PAM_MODULE_DIR)/$(PAM_NAME).so
@@ -158,15 +174,17 @@
 PAM_CONFIG_DIR := $(PREFIX)/share/pam-configs
 
 install-pam: $(PAM_MODULE)
-	install -d $(PAM_MODULE_DIR)
-	install $(PAM_MODULE) $(PAM_MODULE_DIR)
+	install -d $(DESTDIR)$(PAM_MODULE_DIR)
+	install $(PAM_MODULE) $(DESTDIR)$(PAM_MODULE_DIR)
 
 	m4 --define=PAM_INSTALL_PATH=$(PAM_INSTALL_PATH) < $(PAM_NAME)/config > $(PAM_CONFIG)
-	install -d $(PAM_CONFIG_DIR)
-	install $(PAM_CONFIG) $(PAM_CONFIG_DIR)/$(NAME)
+	install -d $(DESTDIR)$(PAM_CONFIG_DIR)
+	install $(PAM_CONFIG) $(DESTDIR)$(PAM_CONFIG_DIR)/$(NAME)
 
 uninstall:
-	rm -f $(DESTDIR)/$(NAME) $(PAM_INSTALL_PATH) $(PAM_CONFIG_DIR)/$(NAME)
+	rm -f $(DESTDIR)$(BINDIR)/$(NAME) \
+	      $(DESTDIR)$(PAM_INSTALL_PATH) \
+	      $(DESTDIR)$(PAM_CONFIG_DIR)/$(NAME)
 
 #### Tool Building Commands ####
 TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports staticcheck gocovmerge misspell)
@@ -174,25 +192,17 @@
 tools: $(TOOLS)
 
 $(BIN)/golint:
-	GO111MODULE=off go get golang.org/x/lint/golint
-	GO111MODULE=off go build -o $@ golang.org/x/lint/golint
+	go build -o $@ golang.org/x/lint/golint
 $(BIN)/protoc-gen-go:
-	GO111MODULE=off go get -d github.com/golang/protobuf/protoc-gen-go
-	git -C "$(shell go env GOPATH)/src/github.com/golang/protobuf" checkout v1.2.0
-	go install github.com/golang/protobuf/protoc-gen-go
-	GO111MODULE=off go build -o $@ github.com/golang/protobuf/protoc-gen-go
+	go build -o $@ github.com/golang/protobuf/protoc-gen-go
 $(BIN)/goimports:
-	GO111MODULE=off go get golang.org/x/tools/cmd/goimports
-	GO111MODULE=off go build -o $@ golang.org/x/tools/cmd/goimports
+	go build -o $@ golang.org/x/tools/cmd/goimports
 $(BIN)/staticcheck:
-	GO111MODULE=off go get honnef.co/go/tools/cmd/staticcheck
-	GO111MODULE=off go build -o $@ honnef.co/go/tools/cmd/staticcheck
+	go build -o $@ honnef.co/go/tools/cmd/staticcheck
 $(BIN)/gocovmerge:
-	GO111MODULE=off go get github.com/wadey/gocovmerge
-	GO111MODULE=off go build -o $@ github.com/wadey/gocovmerge
+	go build -o $@ github.com/wadey/gocovmerge
 $(BIN)/misspell:
-	GO111MODULE=off go get github.com/client9/misspell
-	GO111MODULE=off go build -o $@ github.com/client9/misspell/cmd/misspell
+	go build -o $@ github.com/client9/misspell/cmd/misspell
 
 # Non-go tools downloaded from appropriate repository
 PROTOC_VERSION := 3.6.1

=== debian/changelog ===
fscrypt (0.2.9-1) unstable; urgency=medium

  * New upstream version 0.2.9.
  * Drop patch: 0001-cmd-fscrypt-fix-32-bit-build (upstreamed).

 -- Paride Legovini <paride@debian.org>  Mon, 15 Jun 2020 21:41:10 +0000

fscrypt (0.2.8-1) unstable; urgency=medium

  * New upstream version 0.2.8.
    - closes: #957239 (https://github.com/google/fscrypt/pull/224)
    - closes: #959531 (https://github.com/google/fscrypt/pull/221)
  * New patch: 0001-cmd-fscrypt-fix-32-bit-build.patch (cherry-pick)

 -- Paride Legovini <paride@debian.org>  Tue, 02 Jun 2020 23:00:54 +0000

fscrypt (0.2.7-1) unstable; urgency=medium

  * New upstream version 0.2.7 (closes: #959163).
  * d/rules: run dh_auto_install with --no-source.
  * d/rules: do not try to force -buildmode=pie.
  * d/control: bump the dh compat level to 13.
  * d/control: use the paride@debian.org alias in Uploaders.

 -- Paride Legovini <paride@debian.org>  Mon, 04 May 2020 13:06:29 +0000

fscrypt (0.2.6-1) unstable; urgency=medium

  * New upstream version 0.2.6 (closes: #952667).
  * d/copyright: drop the Files-Excluded section (not needed).
  * d/control: bump Standards-Version to 4.5.0 (no changes needed).
  * d/rules: the 'crypto' testsuite has been renamed to 'keyring'.

 -- Paride Legovini <pl@ninthfloor.org>  Wed, 04 Mar 2020 14:23:52 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: admin
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
-Uploaders: Paride Legovini <pl@ninthfloor.org>
-Build-Depends: debhelper-compat (= 12),
+Uploaders: Paride Legovini <paride@debian.org>
+Build-Depends: debhelper-compat (= 13),
                dh-exec,
                dh-golang (>= 1.35),
                golang-any (>= 2:1.10~),
@@ -14,7 +14,7 @@
                golang-goprotobuf-dev,
                libpam0g-dev,
                m4
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/google/fscrypt
 Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
 Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git

=== debian/rules ===
--- 
+++ 
@@ -9,15 +9,6 @@
 
 ### Set some build flags.
 ### Partially borrowed from upstream Makefile
-
-# As of Go 1.11, -buildmode=pie not supported on linux/mips.
-#
-# REMINDER:
-# On new releases of Go check the release notes to see if we can get
-# rid of this exclusion. E.g. https://golang.org/doc/go1.11#compiler
-ifeq ($(filter $(DEB_HOST_ARCH),mips mipsel mips64el),)
-GO_FLAGS += -buildmode=pie
-endif
 
 GO_LINK_FLAGS := -s -w
 VERSION_FLAG := -X "main.version=v$(DEB_VERSION_UPSTREAM)"
@@ -43,17 +34,18 @@
 	ls -l obj-*/pkg/*/$(DH_GOPKG)/*.a
 	SOPATH=$$(dirname obj-*/pkg/*/$(DH_GOPKG)/*.a) && mv -v $$SOPATH/*.a $$SOPATH/pam_fscrypt.so
 
-	# Old workaround, for future reference:
-	#rename.ul -v .a .so obj-*/pkg/*/$(DH_GOPKG)/*.a
-
 override_dh_auto_test:
 	# Excluded tests:
 	#
-	# crypto:     needs a user keyring linked into the session keyring
+	# keyring:     needs a user keyring linked into the session keyring
 	#             https://github.com/google/fscrypt/issues/99
 	# filesystem: requires a filesystem to test upon and root privileges
 
-	DH_GOLANG_EXCLUDES="crypto filesystem" dh_auto_test
+	DH_GOLANG_EXCLUDES="keyring filesystem" dh_auto_test
+
+override_dh_auto_install:
+	# See dh-golang(3)
+	dh_auto_install -- --no-source
 
 override_dh_install:
 	dh_install

## fscrypt 0.3.3

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 # the License.
 
 # Update on each new release!!
-VERSION := v0.2.9
+VERSION := v0.3.3
 NAME := fscrypt
 PAM_NAME := pam_$(NAME)
 
@@ -28,6 +28,7 @@
 # BINDIR: Where to install the fscrypt binary.        Default: $(PREFIX)/bin
 # PAM_MODULE_DIR: Where to install pam_fscrypt.so.    Default: $(PREFIX)/lib/security
 # PAM_CONFIG_DIR: Where to install Ubuntu PAM config. Default: $(PREFIX)/share/pam-configs
+#   If the empty string, then the Ubuntu PAM config will not be installed.
 #
 # MOUNT: The filesystem where our tests are run.    Default: /mnt/fscrypt_mount
 #   Ex: make test-setup MOUNT=/foo/bar
@@ -95,7 +96,7 @@
 	go build $(GO_FLAGS) -o $@ ./cmd/$(NAME)
 
 $(PAM_MODULE): $(GO_FILES) $(C_FILES)
-	go build -buildmode=c-shared $(GO_FLAGS) -o $@ ./$(PAM_NAME)
+	go build $(GO_FLAGS) -buildmode=c-shared -o $@ ./$(PAM_NAME)
 	rm -f $(BIN)/$(PAM_NAME).h
 
 gen: $(BIN)/protoc $(BIN)/protoc-gen-go $(PROTO_FILES)
@@ -110,6 +111,7 @@
 	go list ./... | xargs -L1 golint -set_exit_status
 	staticcheck ./...
 	misspell -source=text $(FILES)
+	shellcheck -s bash cmd/fscrypt/fscrypt_bash_completion
 	( cd cli-tests && shellcheck -x *.sh)
 
 clean:
@@ -158,8 +160,8 @@
 	@go test -coverpkg=./... -covermode=count -coverprofile=$@ -p 1 ./$* 2> /dev/null
 
 ###### Installation Commands (require sudo) #####
-.PHONY: install install-bin install-pam uninstall
-install: install-bin install-pam
+.PHONY: install install-bin install-pam uninstall install-completion
+install: install-bin install-pam install-completion
 
 PREFIX := /usr/local
 BINDIR := $(PREFIX)/bin
@@ -176,15 +178,24 @@
 install-pam: $(PAM_MODULE)
 	install -d $(DESTDIR)$(PAM_MODULE_DIR)
 	install $(PAM_MODULE) $(DESTDIR)$(PAM_MODULE_DIR)
-
+ifdef PAM_CONFIG_DIR
 	m4 --define=PAM_INSTALL_PATH=$(PAM_INSTALL_PATH) < $(PAM_NAME)/config > $(PAM_CONFIG)
 	install -d $(DESTDIR)$(PAM_CONFIG_DIR)
 	install $(PAM_CONFIG) $(DESTDIR)$(PAM_CONFIG_DIR)/$(NAME)
+endif
+
+COMPLETION_INSTALL_DIR := $(PREFIX)/share/bash-completion/completions
+
+install-completion: cmd/fscrypt/fscrypt_bash_completion
+	install -Dm644 $< $(DESTDIR)$(COMPLETION_INSTALL_DIR)/fscrypt
 
 uninstall:
 	rm -f $(DESTDIR)$(BINDIR)/$(NAME) \
 	      $(DESTDIR)$(PAM_INSTALL_PATH) \
-	      $(DESTDIR)$(PAM_CONFIG_DIR)/$(NAME)
+	      $(DESTDIR)$(COMPLETION_INSTALL_DIR)/fscrypt
+ifdef PAM_CONFIG_DIR
+	rm -f $(DESTDIR)$(PAM_CONFIG_DIR)/$(NAME)
+endif
 
 #### Tool Building Commands ####
 TOOLS := $(addprefix $(BIN)/,protoc golint protoc-gen-go goimports staticcheck gocovmerge misspell)

=== debian/changelog ===
fscrypt (0.3.3-1) unstable; urgency=medium

  * New upstream version 0.3.1.
    Closes: #1006485, tracking:
     - CVE-2022-25326
     - CVE-2022-25327
     - CVE-2022-25328
  * d/gbp.conf: debian-branch = debian/latest (DEP-14)
  * d/copyright: update copyright years for debian/*

 -- Paride Legovini <paride@debian.org>  Mon, 07 Mar 2022 21:32:01 +0000

fscrypt (0.3.1-1) unstable; urgency=medium

  * New upstream version 0.3.1
  * d/copyright: update the maintainer email address (paride@debian.org)
  * d/control: bump Standards-Version to 4.6.0, no changes needed
  * debian/*: wrap-and-sort -bast (cosmetic)

 -- Paride Legovini <paride@debian.org>  Sun, 31 Oct 2021 17:09:10 +0000

=== debian/control ===
Source: fscrypt
Section: admin
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Paride Legovini <paride@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 dh-golang (>= 1.35),
 golang-any (>= 2:1.10~),
 golang-github-pkg-errors-dev,
 golang-github-urfave-cli-dev,
 golang-golang-x-crypto-dev (>= 1:0.0~git20180322.88942b9),
 golang-golang-x-sys-dev,
 golang-goprotobuf-dev,
 libpam0g-dev,
 m4,
Standards-Version: 4.6.0
Homepage: https://github.com/google/fscrypt
Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
XS-Go-Import-Path: github.com/google/fscrypt
Testsuite: autopkgtest-pkg-go
Rules-Requires-Root: no

Package: fscrypt
Architecture: linux-any
Built-Using:
 ${misc:Built-Using},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libpam-fscrypt,
Description: Tool for managing Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping,
 PAM integration, and provides a uniform interface for creating and
 modifying encrypted directories.
 .
 To use fscrypt, you must have a filesystem with encryption enabled and
 a kernel that supports reading/writing from that filesystem. Currently,
 ext4, F2FS, and UBIFS support Linux filesystem encryption. Ext4 has
 supported Linux filesystem encryption since v4.1, F2FS added support
 in v4.2, and UBIFS added support in v4.10. Other filesystems may add
 support for native encryption in the future.

Package: libpam-fscrypt
Architecture: linux-any
Built-Using:
 ${misc:Built-Using},
Depends:
 fscrypt,
 ${misc:Depends},
 ${shlibs:Depends},
Description: PAM module for Linux filesystem encryption
 fscrypt is a high-level tool for the management of Linux filesystem
 encryption. This tool manages metadata, key generation, key wrapping,
 PAM integration, and provides a uniform interface for creating and
 modifying encrypted directories.
 .
 This PAM module can be used to unlock one or more directories upon user
 login and then lock those directories when the user ends their session.

## fscrypt 0.3.4

=== debian/changelog ===
fscrypt (0.3.4-2) unstable; urgency=medium

  * d/libpam-fscrypt.install: install PAM modules into /usr.
    Thanks to Michael Biebl (Closes: 1061581)

 -- Paride Legovini <paride@debian.org>  Mon, 29 Jan 2024 12:10:15 +0100

fscrypt (0.3.4-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable)

  [ Paride Legovini ]
  * New upstream version 0.3.4. (Closes: #1060021)
  * d/control: replace golang-goprotobuf-dev with golang-google-protobuf-dev
  * d/control: bump Standards-Verstion to 4.6.2 (no changes needed)
  * d/copyright: update copyright years for debian/*
  * d/gbp.conf: revert to debian-branch = debian/sid.
    To better comply with the pkg-go team workflow.
  * d/changelog: fix typo in the 0.3.3-1 stanza
  * d/changelog: update my email address in past changelog entries

 -- Paride Legovini <paride@debian.org>  Mon, 08 Jan 2024 22:57:36 +0100

=== debian/control ===
--- 
+++ 
@@ -7,16 +7,16 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-exec,
- dh-golang (>= 1.35),
- golang-any (>= 2:1.10~),
+ dh-golang,
+ golang-any,
  golang-github-pkg-errors-dev,
  golang-github-urfave-cli-dev,
- golang-golang-x-crypto-dev (>= 1:0.0~git20180322.88942b9),
+ golang-golang-x-crypto-dev,
  golang-golang-x-sys-dev,
- golang-goprotobuf-dev,
+ golang-google-protobuf-dev,
  libpam0g-dev,
  m4,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/google/fscrypt
 Vcs-Browser: https://salsa.debian.org/go-team/packages/fscrypt
 Vcs-Git: https://salsa.debian.org/go-team/packages/fscrypt.git
